#!/usr/bin/perl
use Modern::Perl;

my $filepath = "/home/doug/.dosemu/drive_c/EASYTRAX/PROBE/probe.pcb";
my $PCB;

my ($i,$x,$y);
my $xcent = 410;
my $padwide = 820;
my $padtall = 450;
my $vertinc = 550;

# create probe pcb file

sub createfile
{
   open ($PCB, ">","$filepath") or die "couldn't open PCB file $!";
}


sub keepout {
	print $PCB <<"END_OF_STUFF";
PCB FILE 5\r
FT\r
850 0 850 9000 8 12 0\r
FT\r
0 0 0 9000 8 12 0\r
FT\r
0 9000 850 9000 8 12 0\r
FT\r
0 0 0 850 8 12 0\r
END_OF_STUFF
}


sub toppads
{
 my $toppadlines;
 for ($y = $padtall/2;($y+$padtall)<9000;$y+=$vertinc)
 {
  $toppadlines= "FP\r\n";
  $toppadlines .= "$xcent $y $padwide $padtall 4 30 1 1\r\n";
  $toppadlines .= "0\r\n"; 	
  print $PCB $toppadlines;
 }
}


sub bottompads
{
 my $toppadlines;
 for ($y = $padtall/2 + 50;($y+$padtall)<9000;$y+=$vertinc)
 {
  $toppadlines= "FP\r\n";
  $toppadlines .= "$xcent $y $padwide $padtall 4 30 1 6\r\n";
  $toppadlines .= "0\r\n"; 	
  print $PCB $toppadlines;
 }
}

sub vias
{
 my $toppadlines;
 for ($y = $padtall + 75;($y+$padtall)<9000;$y+=$vertinc)
 {
  $toppadlines= "FP\r\n";
  $toppadlines .= "790 $y 62 62 1 0 1 13\r\n";
  $toppadlines .= "0\r\n"; 	
  print $PCB $toppadlines;
 }
}

sub tracks
{
#FT
#790 250 790 505 30 1 1
#FT
#790 545 790 825 30 6 1
my $tracks;
my ($end1,$end2);
for ($y=0; $y<(8500-$padtall);$y += $vertinc)
 {
	$tracks = "FT\r\n";
	$end1 = $y+250;
	$end2 = $y + 505;
	$tracks .= "790 $end1 790 $end2 30 1 1\r\n";
	$tracks .= "FT\r\n";
    $end1 = $y + 545;
    $end2 = $y + 825;
	$tracks .= "790 $end1 790 $end2 30 6 1\r\n";
	print $PCB $tracks;
 }


}


createfile();
keepout();
toppads();
bottompads();
vias();
tracks();

print $PCB "ENDPCB";